<?php

ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
require_once $base_path_to_learning . 'functions/get_branch_functions.php';

//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

$postdata = json_decode(file_get_contents("php://input"), true);
//print_r($postdata);
checkIfNoPhpContentsReceive();

if (
    // !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or
    // !isset($postdata['branch_id']) or !checkIfIssetAndNotEmpty($postdata['branch_id']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type']) or
    !isset($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$institution_id = $jwt_validate->data->institution_id;
$branch_id = $jwt_validate->data->branch_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id, null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

function getSpecific_OtpSettings($conn_rjllearning_specific, $institution_id, $branch_id) {
    $sql = $conn_rjllearning_specific->prepare("SELECT id, homework_setting, otp_setting FROM institution_global_settings WHERE institution_id = ? AND branch_id = ?");
    $sql->execute([$institution_id, $branch_id]);
    $result = $sql->fetch();

    if ($result) {
        $otp_settings = json_decode($result['otp_setting'], true);
        $homework_settings = json_decode($result['homework_setting'], true);
        return [
            'setting_id' => $result['id'],
            'institution_id' => $institution_id,
            'branch_id' => $branch_id,
            'otp_settings' => $otp_settings,
            'homework_setting' => $homework_settings
        ];
    } else {
        errorreturn("OTP settings not found.");
    }
}

if ($postdata['function_type'] == "fetch_specific_otpsettings") {
    // $branch_id = trim($postdata['branch_id']);
    // $institution_id = trim($postdata['institution_id']);
    
    // Validate academic session or access permissions
    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    if ($check_academic_confirmation != true) {
        errorreturn("Access denied. Academic session not active.");
    }
    $isBranchClassSubjectValid = checkBranchClassSubject($conn_rjllearning_specific, $branch_id, null, null, $institution_id);
    if (!$isBranchClassSubjectValid) {
        errorreturn("Invalid branch_id.");
    }
    
    $success['data'] = getSpecific_OtpSettings($conn_rjllearning_specific, $institution_id, $branch_id);
    successreturn($success);
}